function out = readRegister(dev, reg, numbytes, precision)

  ARDUINO_I2C_READREG = 25;

  if nargin < 3 || nargin > 3
    print_usage ();
  endif

  if ~isnumeric(reg)
    error("expected reg to be a number");
  endif
  if ~isnumeric(numbytes)
    error("expected numbytes to be a number");
  endif

  if nargin == 4
    if  !ischar(precision)
      error("expected presision to be s atring");
    endif
    presison = tolower(precision);
    if !strcmp(precision, "uint8") && !strcmp(precision, "int8") && !strcmp(precision, "uint16") && !strcmp(precision, "int16")
      error("expected pression to be (u)int8 or (u)int16 string");
    endif
  else
    precision = 'uint8';
  endif

  % read  reg
  [tmp, sz] = sendCommand(dev.arduinoobj, "", ARDUINO_I2C_READREG, [dev.address reg numbytes]);
  # skip address and reg and return the data
  out = tmp(3:end);

endfunction
