% example using the arduino i2c
% to communicate to a 24XX256 EEPROM chip connected to an uno
%
% COnnection  of arduino to eerpom as follows:
% Arduino    24XX256 eeprom (pin)
% A4      -  5
% A5      -  6
% 5V      -  8
% GND     -  1,2,3,4

pkg load instrument-control

#scanForArduinos

eeprom_address = 0x50;
data = "this is eeprom data";

# open the arduino
a = arduino()
%a = arduino("/dev/ttyACM0", "uno")

unwind_protect

  printf("i2c terminals\n")
  getI2CTerminals(a)

  printf("i2c devices attached\n")
  devs = scanI2Cbus(a)

  idx = find(devs = eeprom_address);
  if isempty(idx)
    warning ('no EEPROM device found at address')
  endif

  printf("opening i2c...\n");

  i2c = i2cdev(a, eeprom_address)

  printf("writing i2c...\n");
  # write data to address 0x0000
  write(i2c, [0 0 uint8(data)]);

  # read from addres 0x0008, which should now be 'eeprom'
  write(i2c, uint8([0 8]));
  val = read(i2c, 6);
  printf("reading from 0x0008 = expecting 'eeprom', got '%s'\n", char(val))

  clear i2c
unwind_protect_cleanup
  clear a
end_unwind_protect
